import { AuthService, User } from "../services/AuthService";
export interface IAuthProvider {
    name: string;
    start?: () => any;
    stop?: () => any;
    authenticateOrCreateUser: (body: any) => Promise<User>;
    update?: (user: User, body: any) => Promise<{}>;
}
export declare abstract class AuthProvider implements IAuthProvider {
    protected service: AuthService;
    readonly abstract name: any;
    start(): Promise<void>;
    stop(): Promise<void>;
    abstract authenticateOrCreateUser(body: any): Promise<User>;
    update(user: User, body: any): Promise<{}>;
}
