import * as Realm from 'realm';
export declare const PermissionSchema: Realm.ObjectSchema;
export declare type PermissionType = {
    userId: string;
    path: string;
    mayRead: boolean;
    mayWrite: boolean;
    mayManage: boolean;
    updatedAt: Date;
};
export declare const PermissionChangeSchema: Realm.ObjectSchema;
export declare type PermissionChange = {
    userId: string;
    realmUrl: string;
    metadataKey?: string;
    metadataValue?: string;
    metadataNameSpace?: string;
    mayRead?: boolean;
    mayWrite?: boolean;
    mayManage?: boolean;
};
export declare const PermissionOfferSchema: Realm.ObjectSchema;
export declare type PermissionOffer = {
    token?: string;
    realmUrl: string;
    mayRead: boolean;
    mayWrite: boolean;
    mayManage: boolean;
    expiresAt?: Date;
};
export declare const PermissionOfferResponseSchema: Realm.ObjectSchema;
export declare type PermissionOfferResponse = {
    token: string;
    realmUrl?: string;
};
export declare const UserSchema: Realm.ObjectSchema;
