"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PermissionSchema = {
    name: 'Permission',
    properties: {
        userId: { type: 'string', optional: false },
        path: { type: 'string', optional: false },
        mayRead: { type: 'bool', optional: false },
        mayWrite: { type: 'bool', optional: false },
        mayManage: { type: 'bool', optional: false },
        updatedAt: { type: 'date', optional: false },
    }
};
exports.PermissionChangeSchema = {
    name: 'PermissionChange',
    properties: {
        userId: { type: 'string' },
        realmUrl: { type: 'string' },
        metadataKey: { type: 'string', optional: true },
        metadataValue: { type: 'string', optional: true },
        metadataNameSpace: { type: 'string', optional: true },
        mayRead: { type: 'bool', optional: true },
        mayWrite: { type: 'bool', optional: true },
        mayManage: { type: 'bool', optional: true }
    }
};
exports.PermissionOfferSchema = {
    name: 'PermissionOffer',
    properties: {
        token: { type: 'string', optional: true, indexed: true },
        realmUrl: { type: 'string' },
        mayRead: { type: 'bool', default: false },
        mayWrite: { type: 'bool', default: false },
        mayManage: { type: 'bool', default: false },
        expiresAt: { type: 'date', optional: true }
    }
};
exports.PermissionOfferResponseSchema = {
    name: 'PermissionOfferResponse',
    properties: {
        token: { type: 'string' },
        realmUrl: { type: 'string', optional: true }
    }
};
exports.UserSchema = {
    name: 'User',
    primaryKey: 'userId',
    properties: {
        userId: { type: 'string', optional: false },
        isAdmin: { type: 'bool', optional: false },
        metadata: { type: 'list', objectType: 'UserMetadataRow', default: [], optional: false }
    }
};
//# sourceMappingURL=models.js.map